#-----------------------------------------------------------------------
# A serie of basic Python commands about syntax restrictions, modules,
# and array-handling.
#
# S.Bardeau, 07-apr-2016 ( gildas _at_ iram.fr )
#-----------------------------------------------------------------------

### Python syntax ###

def abso(x):
   print "input value = " + repr(x)
   if x<0:
	pass
	x = -x
	pass
   elif x==0:
    pass
    pass
   else:
      pass
      pass
   print "output value = " + repr(x)
   return x


a = 1
a%b = 1
10%3   # % is the modulo operator

a.b = 1


### Providing new features to Python: modules ###

import math
math
dir(math)
math.pi
math.cos
math.cos(0)

dir()
from math import cos
dir()
cos(0)

from math import *
dir()


### Array handling is basic in Python ###

a = (1,2,3)
type(a)
b = [1,2,3]
type(b)

c = ("qwerty",1,math.pi,abso,a)
c


### Numpy provides a better handling ###

# Defining a Numpy-array
from numpy import array
a = array((1,2,3))
a
type(a)
b = array([4,5,6],'f')
b

# Numpy tools: example 'reshape()'
from numpy import reshape
range(1,25)
array(range(1,25))
a = reshape(array(range(1,25)),(2,3,4))
a

# Access elements/subarrays
a[0]
a[0][1]
a[0][1][2]
a[0,1,2]

i = (0,1,2)
a[i]

a[:]
a[:,1:,:2]  # Upper bound excluded
















### Sub-arrays ###

from Numeric import zeros
a = zeros((2,3))
a
b = a[0]
b

a[0,0] = 1
b[1] = 2

a
b


a = array((0,0,0))
b = array(a,copy=True)
c = array(a,copy=False) # Not a copy: shares its data with 'a'

a[0] = 1
b[1] = 2
c[2] = 3

a
b
c
